Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.jini.landlord
Class ConstrainableLandlordLease

    java.lang.Object
      com.sun.jini.lease.AbstractLease
          com.sun.jini.landlord.LandlordLease
              com.sun.jini.landlord.ConstrainableLandlordLease

All Implemented Interfaces:
  Lease, ReferentUuid, RemoteMethodControl, Serializable

public final class ConstrainableLandlordLease
extends LandlordLease
implements RemoteMethodControl

Constrainable sub-class of `LandlordLease`. Instances of this class can be verified using the `LandlordProxyVerifier` class.

Since:
  2.0
See Also:
  `LandlordProxyVerifier`, Serialized Form

Field Summary

Fields inherited from class com.sun.jini.lease.AbstractLease
`expiration, serialFormat`

Fields inherited from interface net.jini.core.lease.Lease
`ABSOLUTE, ANY, DURATION, FOREVER`

Constructor Summary
`ConstrainableLandlordLease(Uuid cookie, Landlord landlord, Uuid landlordUuid, long expiration, MethodConstraints methodConstraints)` Create a new `ConstrainableLandlordLease`.

Method Summary
`boolean` | `canBatch(Lease lease)` Returns a boolean indicating whether or not the lease given as a parameter can be batched (placed in the same LeaseMap) with the current lease.
`LeaseMap` | `createLeaseMap(long duration)` Creates a Map object that can contain leases whose renewal or cancellation can be batched, and adds the current lease to that map.
`MethodConstraints` | `getConstraints()` Returns the client constraints placed on this proxy.
`RemoteMethodControl` | `setConstraints(MethodConstraints constraints)` Returns a new copy of this proxy with the client constraints set to the specified constraints.

Methods inherited from class com.sun.jini.landlord.LandlordLease
`cancel, doRenew, equals, getReferentUuid, hashCode, toString`

Methods inherited from class com.sun.jini.lease.AbstractLease
`getExpiration, getSerialFormat, renew, setSerialFormat`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ConstrainableLandlordLease

    public ConstrainableLandlordLease(Uuid cookie,
                                      Landlord landlord,
                                      Uuid landlordUuid,
                                      long expiration,
                                      MethodConstraints methodConstraints)

  Create a new `ConstrainableLandlordLease`.

Parameters:
  `cookie` - a `Uuid` that universally and uniquely identifies the lease this object is to be a proxy for
  `landlord` - `Landlord` object that will be used to communicate renew and cancel requests to the granter of the lease.
  `landlordUuid` - a universally unique id that has been assigned to the server granting of the lease. Ideally the `Uuid` `landlord.getUuid` would return if `landlord` implemented `ReferentUuid`. Used to determine when two leases can be batched together.
  `expiration` - The initial expiration time of the lease in milliseconds since the beginning of the epoch.
  `methodConstraints` - the client method constraints to place on this proxy (may be `null`).
Throws:
  `NullPointerException` - if `landlord`, `landlordUuid`, or `cookie` is `null`.
  `ClassCastException` - if `landlord` does not implement `RemoteMethodControl`.

Method Detail

### setConstraints

    public RemoteMethodControl setConstraints(MethodConstraints constraints)

  Description copied from interface: `RemoteMethodControl`
  Returns a new copy of this proxy with the client constraints set to the specified constraints. These constraints completely replace (in the copy) any client constraints previously placed on this proxy; calling the `getConstraints` method of the copy returns the identical constraints instance. The original proxy is not modified. A `null` value is interpreted as mapping all methods to empty constraints (one that has no requirements and no preferences). For any given remote call, the specific client requirements and preferences to be satisfied are given by the return value of invoking the `getConstraints` method of the specified `MethodConstraints` instance with a `Method` object representing the remote method.

  Client constraints placed on a proxy are included in the serialized state of the proxy. This allows third-party services to be transparent to the client's needs. For example, if remote object `s1` obtains a proxy for remote object `s2`, and passes that proxy to remote object `s3`, expecting `s3` to invoke a remote method on `s2`, then `s1` can control that call by placing its constraints directly on the proxy before passing it to `s3`. If `s3` does not wish to be transparent in this way, then it should explicitly replace the client constraints on received proxies with whatever constraints are appropriate to implement its own policy.

  Specified by:
    `setConstraints` in interface `RemoteMethodControl`
  Parameters:
    `constraints` - client constraints, or `null`
  Returns:
    a new copy of this proxy with the client constraints set to the specified constraints
  See Also:
    `RemoteMethodControl.getConstraints()`

### getConstraints

    public MethodConstraints getConstraints()

  Description copied from interface: `RemoteMethodControl`
  Returns the client constraints placed on this proxy. The return value can be `null`, which is interpreted as mapping all methods to empty constraints (one that has no requirements and no preferences).

  Specified by:
    `getConstraints` in interface `RemoteMethodControl`
  Returns:
    the client constraints, or `null`
  See Also:
    `RemoteMethodControl.setConstraints(net.jini.core.constraint.MethodConstraints)`

### canBatch

    public boolean canBatch(Lease lease)

  Description copied from interface: `Lease`
  Returns a boolean indicating whether or not the lease given as a parameter can be batched (placed in the same LeaseMap) with the current lease. Whether or not two Lease objects can be batched is an implementation detail determined by the objects.

  Specified by:
    `canBatch` in interface `Lease`
  Overrides:
    `canBatch` in class `LandlordLease`

### createLeaseMap

    public LeaseMap createLeaseMap(long duration)

  Description copied from interface: `Lease`
  Creates a Map object that can contain leases whose renewal or cancellation can be batched, and adds the current lease to that map. The current lease is put in the map with the duration value given by the parameter.

  Specified by:
    `createLeaseMap` in interface `Lease`
  Overrides:
    `createLeaseMap` in class `LandlordLease`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Sun Microsystems, Inc. All rights reserved